<?php




function IsData($Day=0) {
	$Day = not_empty($Day,UrTime2Day());
	$r = false;
	if (file_exists("_data/".$Day.".jardin")) $r = true;
	return $r;
	}

function IsMeteo($Day=0) {
	$Day = not_empty($Day,UrTime2Day());
	$r = false;
	if (file_exists("_data/".$Day.".meteo")) $r = true;
	return $r;
	}

function GetData($Day=0) {
	$r = array();
	if (empty($Day)) $Day = UrTime2Day();
	// for ($Day0 = $Day; !IsData($Day) && $Day > ($Day0-10); $Day--) {}
	if (IsData($Day)) {
		foreach (file("_data/".$Day.".jardin") as $Data) {
			list($VarName,$VarValue) = explode(":",trim($Data));
			$r[$VarName] = $VarValue;
			}
		}
	return $r;
	}

function GetMeteo($DataType=0,$Day=0) {
	if (empty($Day)) $Day = (UrTime2Day()-1);
	if (file_exists("_data/".$Day.".meteo")) {
		foreach (file("_data/".$Day.".meteo") as $Data) {
			list($VarName,$VarValue) = explode(":",trim($Data));
			$r[$VarName] = $VarValue;
			}
		}
	if (!empty($DataType)) $r = $r[$DataType];
	return $r;
	}

function GatherData($DataType,$Day=0) {
	$Data = array();
	if (empty($Day)) $Day = (UrTime2Day()-1);
	for ($Day0 = $Day; $Day >= ($Day0-array_item(array('hydratation' => 7, 'temperature' => 2),$DataType)); $Day--) {
		$GetData = GetData($Day);
		if (!empty($GetData[$DataType])) $Data[] = $GetData[$DataType];
		}
	return $Data;
	}

function Echelle($Value,$Paliers) {
	$level = 0;
	foreach ($Paliers as $P) {
		if ($Value >= $P) $level++;
		}
	return $level;
	}


function DonneesMeteo($Day) {
	$Meteo = GetMeteo(null,$Day);
	if ($Day == UrTime2Day()) $Decalage = 1; else $Decalage = 0;
	$Meteo['amhydratation'] = entre(0,($Meteo['hydratation']-$Meteo['ecarth']+$Decalage*$Meteo['decalageh']),Maximum('hydratation'));
	$Meteo['amtemperature'] = entre(0,($Meteo['temperature']-$Meteo['ecartt']+$Decalage*$Meteo['decalaget']),Maximum('temperature'));
	$Meteo['pmhydratation'] = entre(0,($Meteo['hydratation']+$Meteo['ecarth']+$Decalage*$Meteo['decalageh']),Maximum('hydratation'));
	$Meteo['pmtemperature'] = entre(0,($Meteo['temperature']+$Meteo['ecartt']+$Decalage*$Meteo['decalaget']),Maximum('temperature'));
	$Meteo['label'] = Echelle($Meteo['hydratation']+$Decalage*$Meteo['decalageh'],Paliers('hydratation')) . Echelle($Meteo['temperature']+$Decalage*$Meteo['decalaget'],Paliers('temperature')); 
	$Meteo['amlabel'] = Echelle($Meteo['amhydratation']+$Decalage*$Meteo['decalageh'],Paliers('hydratation')) . Echelle($Meteo['amtemperature']+$Decalage*$Meteo['decalaget'],Paliers('temperature')); 
	$Meteo['pmlabel'] = Echelle($Meteo['pmhydratation']+$Decalage*$Meteo['decalageh'],Paliers('hydratation')) . Echelle($Meteo['pmtemperature']+$Decalage*$Meteo['decalaget'],Paliers('temperature'));
	return $Meteo;
	}

	
function Avancement() {
	$DureeTotale = 60;
	$Day = UrTime2Day();
	$T = 0;
	$n = 0;
	for ($d = $Day; $T < 2 && $d > 0; $d--) {
		if ($T == 1 && !file_exists("_data/".$d.".jardin")) $T = 2;
		elseif ($T == 1) $n++;
		elseif (file_exists("_data/".$d.".jardin")) $T = 1;
		$Jardin['debut'] = ($d+1+10);
		}
	$Jardin['fin'] = max(0,($Jardin['debut']+$DureeTotale));
	$Jardin['reste'] = max(0,($Jardin['fin']-$Day));
	$Jardin['fait'] = min($DureeTotale,($Day-$Jardin['debut']));
	$Jardin['ratio'] = max(1,min(100,floor((100*$Jardin['fait']/$DureeTotale))));
	return $Jardin;
	}
	
function Objectifs() {
	$a = array();
	$a['temperature'] = 22;
	$a['hydratation'] = 50;
	return $a;
	}
	
function Objectif($x) {
	$a = Objectifs();
	return $a[$x];
	}
	

function Maximum($DataType) {
	return array_item(Paliers($DataType),(count(Paliers($DataType))-1));
	}

function Paliers($DataType) {
	$a = array();
	$a['hydratation'] = array(20,40,80,100);
	$a['temperature'] = array(5,35,50);
	return $a[$DataType];
	}


function Moyenne($a) {
	$x = array_sum($a);
	$y = not_empty(count($a),1);
	$z = floor(($x/$y));
	return $z;
	}

function entre($min,$num,$max) {
	return max($min,min($num,$max));
	}



function DisplayMeteo($Day) {
	$Meteo = DonneesMeteo($Day);
	$echo = "";
	// $echo .= "<br /><b>Pr&eacute;visions m&eacute;t&eacute;o</b>";
	// $echo .= "<br />Matin : " . $Meteo['amhydratation'] . "% - " . $Meteo['amtemperature'] . "&deg;C / " . $Meteo['amlabel'];
	// $echo .= "<br />Apr&egrave;s-midi : " . $Meteo['pmhydratation'] . "% - " . $Meteo['pmtemperature'] . "&deg;C / " . $Meteo['pmlabel'];
	$echo .= "<div class='col-md-3'>";
	$echo .= "<h3>" . Date4Man($Day) . "</h3>";
	$echo .= "<p>" . date("j",UrDay2Time($Day,12,00)) . " " . mois(date("m",UrDay2Time($Day,12,00))) . " &ndash; ";
	if ($Day == UrTime2Day()) $echo .= "pr&eacute;visionnel"; else $echo .= "constat&eacute;";
	$echo .= "</p>";
	if (file_exists("assets/meteo-" . $Meteo['label'] . ".png")) $echo .= "<p><img src='assets/meteo-" . $Meteo['label'] . ".png' /></p>";
	// $echo .= "<p>Temp&eacute;rature</p>";
	$echo .= "<h3>" . $Meteo['amtemperature'] . "&deg;C / " . $Meteo['pmtemperature'] . "&deg;C</h3>
	<h3>" . $Meteo['amhydratation'] . "% / " . $Meteo['pmhydratation'] . "%</h3>
	</div>";
	return $echo;
	}
	
	
	
		

?>